/*
                        Copyright (c) 1994 by
                        Advanced Visual Systems Inc.
                        All Rights Reserved

        This software comprises unpublished confidential information of
        Advanced Visual Systems Inc. and may not be used, copied or made
        available to anyone, except in accordance with the license
        under which it is furnished.

        This file is under Perforce control
        $Id: //depot/express/fcs992/include/avs/fld.h#1 $
*/
#ifndef FLD_INCLUDED
#define FLD_INCLUDED

#include <avs/om.h>

#ifdef __cplusplus
extern "C" {
#endif
/* access.c */
FUNC_PREFIX OMobj_id FLDadd_elem PTARGS((OMobj_id field, char *temp_name, char *elem_name));
FUNC_PREFIX int FLDadd_int PTARGS((OMobj_id field, char *name));
FUNC_PREFIX int FLDset_int PTARGS((OMobj_id field, char *name, int val));
FUNC_PREFIX int FLDget_int PTARGS((OMobj_id field, char *name, int *val));
FUNC_PREFIX int FLDadd_real PTARGS((OMobj_id field, char *name));
FUNC_PREFIX int FLDset_real PTARGS((OMobj_id field, char *name, double val));
FUNC_PREFIX int FLDget_real PTARGS((OMobj_id field, char *name, double *val));
FUNC_PREFIX int FLDadd_int_array PTARGS((OMobj_id field, char *name, int size));
FUNC_PREFIX int FLDset_array_int PTARGS((OMobj_id field, char *name, int size, int *array, int mode));
FUNC_PREFIX int FLDget_array_int PTARGS((OMobj_id field, char *name, int **array, int *size, int mode));
FUNC_PREFIX int FLDadd_float_array PTARGS((OMobj_id field, char *name, int size));
FUNC_PREFIX int FLDset_array_float PTARGS((OMobj_id field, char *name, int size, float *array, int mode));
FUNC_PREFIX int FLDget_array_float PTARGS((OMobj_id field, char *name, float **array, int *size, int mode));
FUNC_PREFIX int FLDget_array_size PTARGS((OMobj_id e, int *size));
FUNC_PREFIX int FLDequal PTARGS((OMobj_id e1, OMobj_id e2));
FUNC_PREFIX int FLDget_parent_val PTARGS((OMobj_id e, OMobj_id *parent));
FUNC_PREFIX int FLDget_subelem PTARGS((OMobj_id field, char *name, OMobj_id *elem));
FUNC_PREFIX int FLDget_subelem_seq PTARGS((OMobj_id field, char *temp_name));
FUNC_PREFIX OMobj_id FLDcreate PTARGS((OMobj_id parent_id, char *field_desc, char *name));
FUNC_PREFIX int FLDdestroy PTARGS((OMobj_id field));
FUNC_PREFIX int FLDdelete PTARGS((OMobj_id field, char *name));
FUNC_PREFIX int FLDcopy_elem_ref PTARGS((OMobj_id ref, OMobj_id base));
FUNC_PREFIX int FLDcopy_subelem_ref PTARGS((OMobj_id ref, OMobj_id base));
FUNC_PREFIX int FLDget_function PTARGS((OMobj_id elem, char *name, OMpfi *func));
FUNC_PREFIX int FLDget_methods PTARGS((OMobj_id elem, int n, char *names[], OMpfi *func));
FUNC_PREFIX int FLDget_grid_type PTARGS((OMobj_id field, int *grid_type));
FUNC_PREFIX int FLDset_grid_type PTARGS((OMobj_id field, int grid_type));
FUNC_PREFIX int FLDget_ndim PTARGS((OMobj_id field, int *ndim));
FUNC_PREFIX int FLDset_ndim PTARGS((OMobj_id field, int ndim));
FUNC_PREFIX int FLDget_nnodes PTARGS((OMobj_id field, int *nnodes));
FUNC_PREFIX int FLDset_nnodes PTARGS((OMobj_id field, int nnodes));
FUNC_PREFIX int FLDget_dims PTARGS((OMobj_id field, int **dims, int *size));
FUNC_PREFIX int FLDset_dims PTARGS((OMobj_id field, int *dims));
FUNC_PREFIX int FLDget_xform PTARGS((OMobj_id field, float *xform));
FUNC_PREFIX int FLDset_xform PTARGS((OMobj_id field, float *xform));
FUNC_PREFIX int FLDget_rspace PTARGS((OMobj_id field, int *rspace));
FUNC_PREFIX int FLDset_rspace PTARGS((OMobj_id field, int rspace));
FUNC_PREFIX int FLDget_npoints PTARGS((OMobj_id field, int *npoints));
FUNC_PREFIX int FLDset_npoints PTARGS((OMobj_id field, int npoints));
FUNC_PREFIX int FLDget_nspace PTARGS((OMobj_id field, int *nspace));
FUNC_PREFIX int FLDset_nspace PTARGS((OMobj_id field, int nspace));
FUNC_PREFIX int FLDget_coord PTARGS((OMobj_id field, float **coord_array, int *size, int mode));
FUNC_PREFIX int FLDget_sub_coord PTARGS((OMobj_id field, int ndim, int *dims, int *min_rng, int *max_rng, float *coord_array));
FUNC_PREFIX int FLDset_coord PTARGS((OMobj_id field, float *coord_array, int size, int mode));
FUNC_PREFIX int FLDreset_point_extent PTARGS((OMobj_id field));
FUNC_PREFIX int FLDreset_coord_extent PTARGS((OMobj_id field));
FUNC_PREFIX int FLDset_coord_extent PTARGS((OMobj_id field, float *min_extent, float *max_extent, int nspace));
FUNC_PREFIX int FLDget_coord_extent PTARGS((OMobj_id field, float *min_extent, float *max_extent));
FUNC_PREFIX int FLDget_points PTARGS((OMobj_id field, float **points, int *size, int mode));
FUNC_PREFIX int FLDset_points PTARGS((OMobj_id field, float *points, int size, int mode));
FUNC_PREFIX int FLDget_coord_units PTARGS((OMobj_id field, char *units, int size));
FUNC_PREFIX int FLDset_coord_units PTARGS((OMobj_id field, char *units));
FUNC_PREFIX int FLDget_node_data_ncomp PTARGS((OMobj_id field, int *nnode_comp));
FUNC_PREFIX int FLDset_node_data_ncomp PTARGS((OMobj_id field, int nnode_comp));
FUNC_PREFIX int FLDset_node_data_comp PTARGS((OMobj_id field, int comp, int veclen, char *label, char *units));
FUNC_PREFIX int FLDget_node_data_veclen PTARGS((OMobj_id field, int comp, int *veclen));
FUNC_PREFIX int FLDset_node_data_veclen PTARGS((OMobj_id field, int comp, int veclen));
FUNC_PREFIX int FLDget_node_data_type PTARGS((OMobj_id field, int comp, int *type));
FUNC_PREFIX int FLDset_node_data_type PTARGS((OMobj_id field, int comp, int type));
FUNC_PREFIX int FLDget_node_data PTARGS((OMobj_id field, int comp, int *type, char **node_data, int *size, int mode));
FUNC_PREFIX int FLDget_typed_node_data PTARGS((OMobj_id field, int comp, int *type, char **node_data, int *size, int mode));
FUNC_PREFIX int FLDget_sub_node_data PTARGS((OMobj_id field, int comp, int *type, int ndim, int *dims, int *min_rng, int *max_rng, char *node_data));
FUNC_PREFIX int FLDset_node_data PTARGS((OMobj_id field, int comp, char *node_data, int type, int size, int mode));
FUNC_PREFIX int FLDget_node_data_minmax_vec PTARGS((OMobj_id field, int comp, char **min, char **max, int *type, int mode));
FUNC_PREFIX int FLDcopy_node_minmax_vec PTARGS((OMobj_id in_field, OMobj_id out_field, int in_comp, int out_comp));
FUNC_PREFIX int FLDget_node_data_minmax PTARGS((OMobj_id field, int comp, char *min, char *max));
FUNC_PREFIX int FLDset_node_data_minmax PTARGS((OMobj_id field, int comp, char *min, char *max, int dtype));
FUNC_PREFIX int FLDcopy_node_minmax PTARGS((OMobj_id in_field, OMobj_id out_field, int in_comp, int out_comp));
FUNC_PREFIX int FLDreset_node_minmax PTARGS((OMobj_id in_field, int comp));
FUNC_PREFIX int FLDreset_node_minmax_vec PTARGS((OMobj_id in_field, int comp));
FUNC_PREFIX int FLDget_node_data_label PTARGS((OMobj_id field, int comp, char *label, int size));
FUNC_PREFIX int FLDget_node_data_units PTARGS((OMobj_id field, int comp, char *units, int size));
FUNC_PREFIX int FLDget_node_data_id PTARGS((OMobj_id field, int comp, int *id));
FUNC_PREFIX int FLDset_node_data_id PTARGS((OMobj_id field, int comp, int id));
FUNC_PREFIX int FLDget_node_null_data PTARGS((OMobj_id field, int comp, int *null_flag, char *null_value));
FUNC_PREFIX int FLDset_node_null_data PTARGS((OMobj_id field, int comp, char *null_value, int type));
FUNC_PREFIX int FLDset_node_null_flag PTARGS((OMobj_id field, int comp, int null_flag));
FUNC_PREFIX int FLDget_cell_data_ncomp PTARGS((OMobj_id field, int *ncell_comp));
FUNC_PREFIX int FLDset_cell_data_ncomp PTARGS((OMobj_id field, int ncell_comp));
FUNC_PREFIX int FLDset_cell_data_comp PTARGS((OMobj_id field, int comp, int veclen, char *label, char *units));
FUNC_PREFIX int FLDset_cell_data_veclen PTARGS((OMobj_id field, int comp, int veclen));
FUNC_PREFIX int FLDget_cell_data_veclen PTARGS((OMobj_id field, int comp, int *veclen));
FUNC_PREFIX int FLDget_cell_data PTARGS((OMobj_id field, int comp, int *type, char **cell_data, int *size, int mode));
FUNC_PREFIX int FLDget_typed_cell_data PTARGS((OMobj_id field, int comp, int *type, char **cell_data, int *size, int mode));
FUNC_PREFIX int FLDset_cell_data PTARGS((OMobj_id field, int comp, char *cell_data, int type, int size, int mode));
FUNC_PREFIX int FLDset_typed_cell_data PTARGS((OMobj_id field, int comp, char *cell_data, int type, int size, int mode));
FUNC_PREFIX int FLDget_cell_data_minmax_vec PTARGS((OMobj_id field, int comp, char **min, char **max, int *type, int mode));
FUNC_PREFIX int FLDcopy_cell_minmax_vec PTARGS((OMobj_id in_field, OMobj_id out_field, int in_comp, int out_comp));
FUNC_PREFIX int FLDget_cell_data_minmax PTARGS((OMobj_id field, int comp, char *min, char *max));
FUNC_PREFIX int FLDget_cell_data_minmax_total PTARGS((OMobj_id field, int comp, char *min, char* max));
FUNC_PREFIX int FLDset_cell_data_minmax PTARGS((OMobj_id field, int comp, char *min, char *max, int dtype));
FUNC_PREFIX int FLDreset_cell_minmax PTARGS((OMobj_id cell_set, int comp));
FUNC_PREFIX int FLDcopy_cell_minmax PTARGS((OMobj_id in_field, OMobj_id out_field, int in_comp, int out_comp));
FUNC_PREFIX int FLDget_cell_data_label PTARGS((OMobj_id field, int comp, char *label, int size));
FUNC_PREFIX int FLDget_cell_data_units PTARGS((OMobj_id field, int comp, char *units, int size));
FUNC_PREFIX int FLDget_cell_data_id PTARGS((OMobj_id field, int comp, int *id));
FUNC_PREFIX int FLDset_cell_data_id PTARGS((OMobj_id field, int comp, int id));
FUNC_PREFIX int FLDget_cell_data_type PTARGS((OMobj_id field, int comp, int *type));
FUNC_PREFIX int FLDset_cell_data_type PTARGS((OMobj_id field, int comp, int type));
FUNC_PREFIX int FLDget_cell_null_data PTARGS((OMobj_id field, int comp, int *null_flag, char *null_value));
FUNC_PREFIX int FLDset_cell_null_data PTARGS((OMobj_id field, int comp, char *null_value, int type));
FUNC_PREFIX int FLDset_cell_null_flag PTARGS((OMobj_id field, int comp, int null_flag));
FUNC_PREFIX int FLDget_cell_set PTARGS((OMobj_id field, int i, OMobj_id *cell_set));
FUNC_PREFIX int FLDget_cell_set_name PTARGS((OMobj_id field, char *name, int size));
FUNC_PREFIX int FLDget_cell_set_user_name PTARGS((OMobj_id field, char *name, int size));
FUNC_PREFIX int FLDset_cell_set_user_name PTARGS((OMobj_id field, char *name));
FUNC_PREFIX int FLDset_cell_set PTARGS((OMobj_id cell_set, char *cell_set_name));
FUNC_PREFIX int FLDadd_cell_set PTARGS((OMobj_id field, char *cell_set_name));
FUNC_PREFIX int FLDdel_cell_set PTARGS((OMobj_id field, OMobj_id cell_set));
FUNC_PREFIX int FLDget_ncell_sets PTARGS((OMobj_id field, int *ncell_sets));
FUNC_PREFIX int FLDset_ncell_sets PTARGS((OMobj_id field, int ncell_sets));
FUNC_PREFIX int FLDget_ncells PTARGS((OMobj_id cell_set, int *ncells));
FUNC_PREFIX int FLDset_ncells PTARGS((OMobj_id cell_set, int ncells));
FUNC_PREFIX int FLDget_npolys PTARGS((OMobj_id cell_set, int *npolys));
FUNC_PREFIX int FLDset_npolys PTARGS((OMobj_id cell_set, int npolys));
FUNC_PREFIX int FLDget_poly_flag PTARGS((OMobj_id cell_set, int *poly_flag));
FUNC_PREFIX int FLDset_poly_flag PTARGS((OMobj_id cell_set, int poly_flag));
FUNC_PREFIX int FLDget_cell_ndim PTARGS((OMobj_id cell_set, int *ndim));
FUNC_PREFIX int FLDget_cell_order PTARGS((OMobj_id cell_set, int *order));
FUNC_PREFIX int FLDget_cell_type PTARGS((OMobj_id cell_set, int *cell_type));
FUNC_PREFIX int FLDset_cell_type PTARGS((OMobj_id cell_set, int cell_type));
FUNC_PREFIX int FLDget_cell_set_nnodes PTARGS((OMobj_id cell_set, int *cell_nnodes));
FUNC_PREFIX int FLDget_cell_corner_nnodes PTARGS((OMobj_id cell_set, int *cell_nnodes));
FUNC_PREFIX int FLDget_cell_set_nfaces PTARGS((OMobj_id cell_set, int *cell_nfaces));
FUNC_PREFIX int FLDget_cell_faces PTARGS((OMobj_id cell_set, int *nfaces, int **face_nnodes, int **face_corner_nnodes, int **node_list, int *size));
FUNC_PREFIX int FLDget_node_connect PTARGS((OMobj_id cell_set, int **node_conn_array, int *size, int mode));
FUNC_PREFIX int FLDset_node_connect PTARGS((OMobj_id cell_set, int *node_conn_array, int size, int mode));
FUNC_PREFIX int FLDget_poly_connect PTARGS((OMobj_id cell_set, int **poly_conn_array, int *size, int mode));
FUNC_PREFIX int FLDset_poly_connect PTARGS((OMobj_id cell_set, int *poly_conn_array, int size, int mode));
FUNC_PREFIX int FLDget_poly_nnodes PTARGS((OMobj_id cell_set, int **poly_conn_array, int *size, int mode));
FUNC_PREFIX int FLDset_poly_nnodes PTARGS((OMobj_id cell_set, int *poly_conn_array, int size, int mode));
FUNC_PREFIX int FLDget_cell_node_uvw PTARGS((OMobj_id cell_set, float **uvw));
FUNC_PREFIX int FLDget_cell_nprops PTARGS((OMobj_id cell_set, int *nprops));
FUNC_PREFIX int FLDset_cell_nprops PTARGS((OMobj_id cell_set, int nprops));
FUNC_PREFIX int FLDget_cell_props PTARGS((OMobj_id cell_set, float **props, int *size, int mode));
FUNC_PREFIX int FLDcheck_cell_connect PTARGS((OMobj_id cell_set, int nnodes, int *bad_index, int *bad_value));
FUNC_PREFIX int FLDcheck_mesh_connect PTARGS((OMobj_id cell_set, int *bad_index, int *bad_value));

/* dfuncs.c */
FUNC_PREFIX void FLDfunc_init PTARGS((void));
FUNC_PREFIX int FLDget_coords_dims PTARGS((OMobj_id elem_id, int *ndim, int *dims));
FUNC_PREFIX int FLDget_coords_unif PTARGS((OMobj_id elem_id, int req_ndim, int *idims, int *imin_rng, int *imax_rng, float *array));
FUNC_PREFIX int FLDget_coords_rect PTARGS((OMobj_id elem_id, int req_ndim, int *idims, int *imin_rng, int *imax_rng, float *array));
FUNC_PREFIX int FLDget_coords_cyl_unif PTARGS((OMobj_id elem_id, int req_ndim, int *idims, int *imin_rng, int *imax_rng, float *array));
FUNC_PREFIX int FLDget_coords_cyl_rect PTARGS((OMobj_id elem_id, int req_ndim, int *idims, int *imin_rng, int *imax_rng, float *array));
FUNC_PREFIX int FLDget_coords_spher_unif PTARGS((OMobj_id elem_id, int req_ndim, int *idims, int *imin_rng, int *imax_rng, float *array));
FUNC_PREFIX int FLDget_coords_spher_rect PTARGS((OMobj_id elem_id, int req_ndim, int *idims, int *imin_rng, int *imax_rng, float *array));
FUNC_PREFIX int FLDget_connect_dims PTARGS((OMobj_id elem_id, int *req_ndim, int *req_dims));
FUNC_PREFIX int FLDget_connect_struct PTARGS((OMobj_id elem_id, int req_ndim, int *idims, int *imin_rng, int *imax_rng, int *array));
FUNC_PREFIX int get_coords_unif PTARGS((int ndim, int *dims, float *points, int *min_rng, int *max_rng, float *array));
FUNC_PREFIX int get_coords_rect PTARGS((int ndim, int *dims, float *points, int *min_rng, int *max_rng, float *array));
FUNC_PREFIX int get_coords_cyl_unif PTARGS((int ndim, int *dims, float *points, int *min_rng, int *max_rng, float *array));
FUNC_PREFIX int get_coords_cyl_rect PTARGS((int ndim, int *dims, float *points, int *min_rng, int *max_rng, float *array));
FUNC_PREFIX int get_coords_spher_unif PTARGS((int ndim, int *dims, float *points, int *min_rng, int *max_rng, float *array));
FUNC_PREFIX int get_coords_spher_rect PTARGS((int ndim, int *dims, float *points, int *min_rng, int *max_rng, float *array));
FUNC_PREFIX int get_connect_struct PTARGS((int ndim, int *dims, int min_cell, int max_cell, int *array));
/* fld_init.c */
FUNC_PREFIX int FLDinit PTARGS((void));
/* fld_util.c */
FUNC_PREFIX int get_coord_func PTARGS((char *field_table, float **coord));
FUNC_PREFIX int get_points_func PTARGS((char *field_table, float **points));
FUNC_PREFIX int get_connect_func PTARGS((char *field_table, int set, int **node_list));
FUNC_PREFIX int get_sub_coord_func PTARGS((char *field_table, int *min_rng, int *max_rng, float *array));
FUNC_PREFIX int FLDget_mesh_info PTARGS((OMobj_id fld, char **fld_tbl));
FUNC_PREFIX int FLDfree_mesh_info PTARGS((char *fld_tbl));
FUNC_PREFIX OMobj_id FLDadd_block_table PTARGS((OMobj_id fld));
FUNC_PREFIX int FLDinterp_init PTARGS((OMobj_id fld, char *field_table, char **block_table));
FUNC_PREFIX int FLDinterp_end PTARGS((char *block_tbl));

FUNC_PREFIX int FLDget_time_nsteps PTARGS((OMobj_id field, int *nsteps));
FUNC_PREFIX int FLDset_time_nsteps PTARGS((OMobj_id field, int nsteps));
FUNC_PREFIX int FLDget_time_values PTARGS((OMobj_id field, double **time, int *size, int mode));
FUNC_PREFIX int FLDset_time_values PTARGS((OMobj_id field, double *time, int size, int mode));
FUNC_PREFIX int FLDget_time_coordinates PTARGS((OMobj_id field, int step, OMobj_id *coordinates));
FUNC_PREFIX int FLDget_time_node_data PTARGS((OMobj_id field, int step, OMobj_id *node_data));
FUNC_PREFIX int FLDget_time_cell_data PTARGS((OMobj_id cell_set, int step, OMobj_id *cell_data));

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* FLD_INCLUDED */
